???File Path
==========
***...\ClientApp\src\app\src\assets\assets-master\assets-master.component.ts\n\n\n???Check the points
==================
1) Check ...\ClientApp\src\app\src\base\branch\branch.component.ts and ...\ClientApp\src\app\src\base\company\company.component.ts \n2) Main Grouping Must
	-> // @@@@@@@ AREA=> FROM HTML INPUT AREA Called Functions(Not Button bar and List) @@@@@@@@@@@@@@
	-> // @@@@@@@ FROM HTML MAIN LIST Called Functions @@@@@@@@@@@@@@
	-> // @@@@@@@ AREA=> FROM HTML BUTTON BAR Called Functions @@@@@@@@@@@@@@
	-> // @@@@@@@ AREA=> COMMON Functions @@@@@@@@@@@@@@
3) Set GUI Heading in constructor(Eg:- insGlobalConstants.strGuiHeading = "***";)
4) Set GUI/Menu System Name in constructor(Eg:- insGlobalConstants.strSysModuleName = "***";) based on menu service
5) Set GUI Tittle(Browser Tab) in constructor(Eg:- insGlobalFunctions.fnSetGuiBasedBrowserTitle = "***";)



            // ??? Check and Use If you need...
            //---------------------------------
            import { Component, OnInit, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
            import { DxDataGridComponent } from "devextreme-angular";

            import * as globalConstantsService from '../../../services/global-constants.service';
            import * as globalFunctionsService from '../../../services/global-functions.service';
            import * as globalDataService from '../../../services/global-data.service';
            import * as baseDataService from '../../../services/base/base-data.service';
            import * as jspdfService from '../../../services/jspdf.service';
            import * as menuService from '../../../services/menu.service';
            import { MdlAssetsMaster, MdlReqAssetsMaster, MdlResAssetsMaster, MdlResAssetsMasterInit, MdlResAssetsMasterList } from '../../../models/assets/assets.model';
            import { MdlResponse, MdlBaseIntId, MdlReqBaseIntId } from "../../../models/common.model";
            import { HttpService } from '../../../services/http.service';
        


            // ??? Check and Use If you need...
            //---------------------------------
            export class AssetsMasterComponent implements OnInit, AfterViewInit, OnDestroy {
                // ** initialize data
                public mdlAssetsMaster: MdlAssetsMaster = new MdlAssetsMaster();
                public intActiveAssetsMasterIndex: number = -1;
                // ** Select and Auto-completion
                // ??? Remove not use items !!!
			lstMdlAccountBaseIntId: MdlBaseIntId[] = [];
			lstMdlAdCrAccountBaseIntId: MdlBaseIntId[] = [];
			lstMdlDepreciationDrAccountBaseIntId: MdlBaseIntId[] = [];

                // ** GUI Control
                public blnBtnDisabled: boolean = false;
                public blnMoreDivExpanded: boolean = false;
                // ** AssetsMaster List
                @ViewChild('#idDgAssetsMasterList') idDgAssetsMasterList!: DxDataGridComponent;
                public lstAllAssetsMaster: MdlAssetsMaster[] = [];
                public blnDgAssetsMasterShowFilterRow: boolean = false;
                public blnDgAssetsMasterHeaderFilter: boolean = false;
                public intActiveAssetsMasterListItemIndex = -1;
        


                // ??? If you need, import and create instance other common classes !!!
                constructor(public insGlobalConstants: globalConstantsService.GlobalConstantsService,
                        public insGlobalFunctions: globalFunctionsService.GlobalFunctionsService,
                        public insGlobalData: globalDataService.GlobalDataService,
                        public insBaseData: baseDataService.BaseDataService,
                        private insHttpService: HttpService,
                        public insJspdf: jspdfService.JspdfService) {
    
                    insGlobalConstants.strGuiHeading = 'assetsMaster';
                    // ??? Check menu service !!!
                    insGlobalConstants.strSysModuleName = "ASSETSMASTER_MASTER";
                    insGlobalFunctions.fnSetGuiBasedBrowserTitle("AssetsMaster");
                }

                ngOnInit(): void {
                    this.blnBtnDisabled = true;
                    document.body.style.cursor = "wait";

                    this.fnDefaultView();

                    // initialize Data Request
                    this.insHttpService.get('Base/Organization/GetAssetsMasterInitializeData')
                    .then((mdlResAssetsMasterInit: MdlResAssetsMasterInit) => {
                        if (mdlResAssetsMasterInit.sinStatus == 1) {
                            this.lstMdlAssetsMaster = mdlResAssetsMasterInit.lstMdlAssetsMaster;

                            // ??? Remove not use items !!!
					this.lstMdlAccountBaseIntId = mdlResAssetsMasterInit.lstMdlAccountBaseIntId;
					this.lstMdlAdCrAccountBaseIntId = mdlResAssetsMasterInit.lstMdlAdCrAccountBaseIntId;
					this.lstMdlDepreciationDrAccountBaseIntId = mdlResAssetsMasterInit.lstMdlDepreciationDrAccountBaseIntId;

                        } else {
                            console.log(mdlResAssetsMasterInit.strMessage + " => " + mdlResAssetsMasterInit.strErrorCode + ' -> ' + mdlResAssetsMasterInit.strSysError);
                        }
                    })
                    .catch((err: any) => {
                        console.log("Error->ASSETSMASTER.COMPONENT.TS#001: " + JSON.stringify(err));
                    });

                    document.body.style.cursor = "default";
                    this.blnBtnDisabled = false;
                }

                ngAfterViewInit(): void {
                }

                ngOnDestroy() {
                }
        


            // @@@@@@@ AREA=> FROM HTML INPUT AREA Called Functions(Not Button bar and List) @@@@@@@@@@@@@


            // ??? AUTO/ENTRY COMPLETE - Set Id[, Code, Name] -> OnFocusOut Event

            // ??? Any caculation/Display Based on user inputs

        


            // @@@@@@@@@@@@@@@@@@@@@@@ AREA=> FROM HTML MAIN LIST Called Functions @@@@@@@@@@@@@@@@@@@@@@@@

            fnOnAssetsMasterListEditButtonClick(objSelRow: any) {
                this.blnBtnDisabled = true;
                document.body.style.cursor = "wait";

                this.fnSetDataAndGuiEditMode(objSelRow.row.data, objSelRow.row.rowIndex);

                document.body.style.cursor = "default";
                this.blnBtnDisabled = false;
            }

            fnOnAssetsMasterListRowDblClick(objDblClickRowData: any) {
                this.blnBtnDisabled = true;
                document.body.style.cursor = "wait";

                this.fnSetDataAndGuiEditMode(objDblClickRowData.data, objDblClickRowData.rowIndex);

                document.body.style.cursor = "default";
                this.blnBtnDisabled = false;
            }

            fnOnDgFilterRowEnableDisableClick() {
                this.blnDgShowFilterRow = !this.blnDgShowFilterRow;
            }

            fnOnDgHeadeFilterEnableDisableClick() {
                this.blnDgHeaderFilter = !this.blnDgHeaderFilter;
            }
        


            // @@@@@@@@@@@@@@@@@@@@@@ AREA=> FROM HTML BUTTON BAR Called Functions @@@@@@@@@@@@@@@@@@@@@@@@

            async fnOnSaveButtonClick() {
            this.blnBtnDisabled = true;
            document.body.style.cursor = "wait";
            this.fnDefaultView(false, true, true, false);

            // Add or Update 
            try {
            // Input Validation
            this.fnInputValidation(this.mdlAssetsMaster);

            // Input Data set
            //....

            // Set Save Request Inputs
            let mdlReqAssetsMaster: MdlReqAssetsMaster = new MdlReqAssetsMaster();
            mdlReqAssetsMaster.mdlAssetsMaster = JSON.parse(JSON.stringify(this.mdlAssetsMaster));

            // Request Data Reset
            //....

            // Save Request
            await this.insHttpService.post('Base/Organization/SaveAssetsMaster', mdlReqAssetsMaster)
                .then((mdlResAssetsMaster: MdlResAssetsMaster) => {
                if (mdlResAssetsMaster.sinStatus == 1) {
                    this.mdlAssetsMaster = mdlResAssetsMaster.mdlAssetsMaster;
                    if (this.intActiveAssetsMasterIndex == -1) {
                    // New Item
                    this.intActiveAssetsMasterIndex = this.lstMdlAssetsMaster.length;
                    this.lstMdlAssetsMaster.push(JSON.parse(JSON.stringify(this.mdlAssetsMaster)));
                    }
                    else {
                    // Update
                    this.lstMdlAssetsMaster[this.intActiveAssetsMasterIndex] = JSON.parse(JSON.stringify(this.mdlAssetsMaster));
                    //this.lstMdlAssetsMaster.splice(this.intActiveAssetsMasterIndex, 1, this.mdlAssetsMaster);
                    }

                    this.insGlobalConstants.fnSetSuccessMessage(mdlResAssetsMaster.strMessage);
                } else {
                    this.insGlobalConstants.fnSetErrorMessage(mdlResAssetsMaster.strMessage, mdlResAssetsMaster.strSysError);
                    console.log(mdlResAssetsMaster);
                }
                })
                .catch((err: any) => {
                    this.insGlobalConstants.fnSetErrorMessage(JSON.stringify(err));
                });

            } catch (ex: unknown) {
                if (ex instanceof Error) {
                    //this.insGlobalConstants.strErrorMessages = ex.message;
                    this.insGlobalConstants.fnSetErrorMessage(ex.message);
                }
                console.log("Error->ASSETSMASTER.COMPONENT.TS#002: " + ex);
            }

            this.fnDefaultView(false, false, true, false);
            document.body.style.cursor = "default";
            this.blnBtnDisabled = false;
        }

        fnOnNewButtonClick() {
            this.blnBtnDisabled = true;
            document.body.style.cursor = "wait";

            this.fnDefaultView(true, true, true, false);

            document.body.style.cursor = "default";
            this.blnBtnDisabled = false;
        }

        async fnOnDeleteButtonClick() {
            this.blnBtnDisabled = true;
            document.body.style.cursor = "wait";
            this.fnDefaultView(false, true, false, false);

            // Delete 
            try {

            // Input Validation
            if (this.mdlAssetsMaster.binAssetsMasterId == null || this.mdlAssetsMaster.binAssetsMasterId < 1) {
                throw new Error('Select AssetsMaster for DELETE.');
            }

            // Set Delete Request Inputs
            let mdlReqAssetsMasterBaseIntId: MdlReqBaseIntId = new MdlReqBaseIntId();
            mdlReqAssetsMasterBaseIntId.mdlBaseIntId.binPkId = this.mdlAssetsMaster.binAssetsMasterId;
            mdlReqAssetsMasterBaseIntId.mdlBaseIntId.binCustomValue = this.mdlAssetsMaster.intSysActionId;
            
            // Delete Request
            await this.insHttpService.post('Base/Organization/DeleteAssetsMaster', mdlReqAssetsMasterBaseIntId)
                .then((mdlResponse: MdlResponse) => {
                if (mdlResponse.sinStatus == 1) {
                    this.lstMdlAssetsMaster.splice(this.intActiveAssetsMasterIndex, 1);
                    this.fnDefaultView(true, false, false, false);
                    this.insGlobalConstants.fnSetSuccessMessage(mdlResponse.strMessage);
                } else {
                    this.insGlobalConstants.fnSetErrorMessage(mdlResponse.strMessage, mdlResponse.strSysError);
                    console.log(mdlResponse);
                }
                })
                .catch((err: any) => {
                this.insGlobalConstants.fnSetErrorMessage(JSON.stringify(err));
                });

            } catch (ex: unknown) {
            if (ex instanceof Error) {
                this.insGlobalConstants.fnSetErrorMessage(ex.message);
            }
            console.log("Error->ASSETSMASTER.COMPONENT.TS#003: " + ex);
            }

            document.body.style.cursor = "default";
            this.blnBtnDisabled = false;
        }

        


            // @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ AREA=> COMMON Functions @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


            fnDefaultView(blnClearData: boolean = true, blnClearMessages: boolean = true, blnMoreDivExpanded: boolean = false, blnGotoBottom: boolean = false) {
                if (blnClearData) {
                    this.mdlAssetsMaster = new MdlAssetsMaster();
                    this.intActiveAssetsMasterIndex = -1;
                }

                this.blnMoreDivExpanded = blnMoreDivExpanded;

                if (blnClearMessages) {
                    this.insGlobalConstants.strErrorMessages = "";
                    this.insGlobalConstants.strSuccessMessages = "";
                }
                
                if (!blnGotoBottom)
                    this.insGlobalFunctions.fnWindowScrollTop();
                else {
                    this.insGlobalFunctions.fnWindowScrollbottom();
                }
            }

            fnSetDataAndGuiEditMode(mdlAssetsMaster: MdlAssetsMaster, intRowIndex: number) {
                this.mdlAssetsMaster = JSON.parse(JSON.stringify(mdlAssetsMaster));
                this.intActiveAssetsMasterIndex = intRowIndex;
                this.fnDefaultView(false, true, true, false);
            }

            fnInputValidation(mdlAssetsMaster: MdlAssetsMaster) {
                // ??? CHECK
                
                if (mdlAssetsMaster.binAccountId == 0) {
                    throw new Error('Enter/Select Account.');
                }
            
                if (mdlAssetsMaster.strCodePrefix == "") {
                    throw new Error('Enter/Select Code Prefix.');
                }
            
                if (mdlAssetsMaster.binCodePartLastNumber == 0) {
                    throw new Error('Enter/Select Code Part Last Number.');
                }
            

                // ??? CHECK CODE and NAME [Other UNIQUE Fields] Already exists
            }
        

