???File Path
==========
***...\Models\assets\AssetsModels.cs\n\n\n// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
// @@@@@@@@@@@@@@@@@  AssetsMaster  @@@@@@@@@@@@@@@@@
// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
public class MdlAssetsMaster {

	public long binAssetsMasterId { get; set; } = 0;
	
	[Required()]
	[Display(Name = "Account")]
	public long binAccountId { get; set; } = 0;
	public long? binAdCrAccountId { get; set; } = null;
	public long? binDepreciationDrAccountId { get; set; } = null;
	public short sinDepreciationBasedOn { get; set; } = 0;
	public double dblDepreciationPerc { get; set; } = 0.0;
	
	public short sinInCodeSetBranchCode { get; set; } = 0;
	[Required(AllowEmptyStrings = false)]
	[DisplayFormat(ConvertEmptyStringToNull = false)]
	[StringLength(5)]
	[Display(Name = "Code Prefix")]
	public string strCodePrefix { get; set; } = "";
	[Required()]
	[Display(Name = "Code Part Last Number")]
	public long binCodePartLastNumber { get; set; } = 0;
	
}

public class MdlReqAssetsMaster : MdlRequest {

	public MdlAssetsMaster mdlAssetsMaster { get; set; } = new MdlAssetsMaster();
}

public class MdlResAssetsMaster : MdlResponse {

	public MdlAssetsMaster mdlAssetsMaster { get; set; } = new MdlAssetsMaster();
}

public class MdlResAssetsMasterList : MdlResponse {

	public List<MdlAssetsMaster> lstMdlAssetsMaster { get; set; } = new List<MdlAssetsMaster>();
}

public class MdlResAssetsMasterInit : MdlResponse {
	public List<MdlBaseIntId> lstMdlAccountBaseIntId { get; set; } = new List<MdlBaseIntId>();
	public List<MdlBaseIntId> lstMdlAdCrAccountBaseIntId { get; set; } = new List<MdlBaseIntId>();
	public List<MdlBaseIntId> lstMdlDepreciationDrAccountBaseIntId { get; set; } = new List<MdlBaseIntId>();


	public List<MdlAssetsMaster> lstMdlAssetsMaster { get; set; } = new List<MdlAssetsMaster>();
}

