???File Path
==========
***...\ClientApp\src\app\models\base\assets.model.ts\n\n\n// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
// @@@@@@@@@@@@@@@@@  AssetsMaster  @@@@@@@@@@@@@@@@@
// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
export class MdlAssetsMaster {

	binAssetsMasterId: number = 0;
	
	binAccountId: number = 0;
	strAccountCode: string = "";
	strAccountName: string = "";
	binAdCrAccountId: number | null = null;
	strAdCrAccountCode: string = "";
	strAdCrAccountName: string = "";
	binDepreciationDrAccountId: number | null = null;
	strDepreciationDrAccountCode: string = "";
	strDepreciationDrAccountName: string = "";
	sinDepreciationBasedOn: number = 0;
	dblDepreciationPerc: number = 0.0;
	
	sinInCodeSetBranchCode: number = 0;
	strCodePrefix: string = "";
	binCodePartLastNumber: number = 0;
	
}

export class MdlReqAssetsMaster extends MdlRequest {

	mdlAssetsMaster:MdlAssetsMaster = new MdlAssetsMaster();
}

export class MdlResAssetsMaster extends MdlResponse {

	mdlAssetsMaster:MdlAssetsMaster = new MdlAssetsMaster();
}

export class MdlResAssetsMasterList extends MdlResponse {

	lstMdlAssetsMaster: MdlAssetsMaster[] = [];
}

export class MdlResAssetsMasterInit extends MdlResponse {
	lstMdlAccountBaseIntId: MdlBaseIntId[] = [];
	lstMdlAdCrAccountBaseIntId: MdlBaseIntId[] = [];
	lstMdlDepreciationDrAccountBaseIntId: MdlBaseIntId[] = [];


	lstMdlAssetsMaster: MdlAssetsMaster[] = [];
}

